#include "flash_spi.h"

static __IO uint32_t SPITimeout = SPI_LONG_TIMEOUT;

/**
  * @brief  Basic management of the timeout situation.
  * @param  errorCode룬λĸڳ.
  * @retval 0ʾIICȡʧ.
  */
static uint8_t SPI_TIMEOUT_UserCallback(uint8_t errorCode)
{
    FLASH_ERROR("SPI ȴʱerrorCode = %d", errorCode);
    return 0;
}

void FLASH_SPI_Init(void)
{
    GPIO_InitTypeDef GPIO_InitStruct;
    SPI_InitTypeDef  SPI_InitStruct;

    FLASH_SPI_CLOCKCMD(FLASH_SPI_PERIPH, ENABLE);

    FLASH_SPI_CS_GPIO_CLOCKCMD(FLASH_SPI_CS_GPIO_PERIPH | FLASH_SPI_SCK_GPIO_PERIPH |
                               FLASH_SPI_MISO_GPIO_PERIPH | FLASH_SPI_MOSI_GPIO_PERIPH, ENABLE);

    //CS
    GPIO_InitStruct.GPIO_Pin = FLASH_SPI_CS_GPIO_PIN;
    GPIO_InitStruct.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_InitStruct.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(FLASH_SPI_CS_GPIO_PORT, &GPIO_InitStruct);

    //CSرգCSߵƽ
    FLASH_SPI_CS_STATE(OFF);

    //SCK
    GPIO_InitStruct.GPIO_Pin = FLASH_SPI_SCK_GPIO_PIN;
    GPIO_InitStruct.GPIO_Mode = GPIO_Mode_AF_PP;
    GPIO_InitStruct.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(FLASH_SPI_SCK_GPIO_PORT, &GPIO_InitStruct);

    //MISO
    GPIO_InitStruct.GPIO_Pin = FLASH_SPI_MISO_GPIO_PIN;
    GPIO_InitStruct.GPIO_Mode = GPIO_Mode_IN_FLOATING;
    GPIO_Init(FLASH_SPI_MISO_GPIO_PORT, &GPIO_InitStruct);

    //MOSI
    GPIO_InitStruct.GPIO_Pin = FLASH_SPI_MOSI_GPIO_PIN;
    GPIO_InitStruct.GPIO_Mode = GPIO_Mode_AF_PP;
    GPIO_InitStruct.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(FLASH_SPI_MOSI_GPIO_PORT, &GPIO_InitStruct);

    //SPIṹ
    SPI_InitStruct.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_4;//f_pclk2 / 2
    SPI_InitStruct.SPI_CPHA = SPI_CPHA_2Edge;//ʱżز
    SPI_InitStruct.SPI_CPOL = SPI_CPOL_High;
    SPI_InitStruct.SPI_CRCPolynomial = 0;//CRCУ飬˴
    SPI_InitStruct.SPI_DataSize = SPI_DataSize_8b;
    SPI_InitStruct.SPI_Direction = SPI_Direction_2Lines_FullDuplex;//ѡ˫ȫ˫
    SPI_InitStruct.SPI_FirstBit = SPI_FirstBit_MSB;
    SPI_InitStruct.SPI_Mode = SPI_Mode_Master;
    SPI_InitStruct.SPI_NSS = SPI_NSS_Soft;//NSSģʽ
    SPI_Init(FLASH_SPIx, &SPI_InitStruct);

    SPI_Cmd(FLASH_SPIx, ENABLE);
}

/**
  * @brief  FLASHͲһֽ
  * @param  data:Ҫ͵ֽ
  * @retval ؽֽܵ
  */
//˴ע͵ķʹõķһԼһȫһ£ע͵ķȷǴ
static uint8_t FLASH_SPI_SendAReceiveByte(uint8_t data)
{
//    SPITimeout = 200;
    SPITimeout = 0;

    while(SPI_I2S_GetFlagStatus(FLASH_SPIx, SPI_I2S_FLAG_TXE) == RESET)//һֽǷ
    {
//        SPITimeout--;
//        if(SPITimeout)
//            return SPI_TIMEOUT_UserCallback(0);
        SPITimeout++;
        if(SPITimeout > 200)
            return SPI_TIMEOUT_UserCallback(0);
    }

    SPI_I2S_SendData(FLASH_SPIx, data);

//    SPITimeout = 200;
    SPITimeout = 0;

    while(SPI_I2S_GetFlagStatus(FLASH_SPIx, SPI_I2S_FLAG_RXNE) == RESET)//Ƿܵһֽ
    {
//        SPITimeout--;
//        if(SPITimeout)
//            return SPI_TIMEOUT_UserCallback(1);
        SPITimeout++;
        if(SPITimeout > 200)
            return SPI_TIMEOUT_UserCallback(1);
    }

    return SPI_I2S_ReceiveData(FLASH_SPIx);
}

/**
  * @brief  ȴFLASH豸ڲʱ
  * @param  
  * @retval 
  */
static void FLASH_SPI_WaitInnerStead(void)
{
    uint8_t status;

    FLASH_SPI_CS_STATE(ON);

    FLASH_SPI_SendAReceiveByte(READ_STATUS_REGISTER1);

    do
    {
        status = FLASH_SPI_SendAReceiveByte(Dummy_Byte);
    }while(status & WIP_Flag);

    FLASH_SPI_CS_STATE(OFF);
}

/**
  * @brief  ȡFLASH豸JEDEC_ID
  * @param  
  * @retval JEDEC_ID
  */
uint32_t FLASH_SPI_ReadID(void)
{
    uint32_t ID = 0x00000000;
//    uint32_t tmp = 0, tmp0 = 0, tmp1 = 0, tmp2 = 0;


//    FLASH_SPI_WaitInnerStead();

    FLASH_SPI_CS_STATE(ON);

    FLASH_SPI_SendAReceiveByte(READ_JEDEC_ID);

    ID |= (((uint32_t)FLASH_SPI_SendAReceiveByte(Dummy_Byte)) << 16);
    ID |= (((uint32_t)FLASH_SPI_SendAReceiveByte(Dummy_Byte)) << 8);
    ID |= (uint32_t)FLASH_SPI_SendAReceiveByte(Dummy_Byte);

//    tmp0 = FLASH_SPI_SendAReceiveByte(Dummy_Byte);
//    tmp1 = FLASH_SPI_SendAReceiveByte(Dummy_Byte);
//    tmp2 = FLASH_SPI_SendAReceiveByte(Dummy_Byte);

    FLASH_SPI_CS_STATE(OFF);

//    tmp = (tmp0 << 16) | (tmp1 << 8) | tmp2;

    return ID;

}

/**
  * @brief  FLASHдʹ
  * @param  
  * @retval 
  */
static void FALSH_SPI_WriteEnable(void)
{
    FLASH_SPI_CS_STATE(ON);

    FLASH_SPI_SendAReceiveByte(WRITE_ENABLE);

    FLASH_SPI_CS_STATE(OFF);
}

/**
  * @brief  FLASHһĴС4KB
  * @param  addr:Ҫĵַ
  * @retval 
  */
void FLASH_SPI_SectorErase(uint32_t addr)
{
    FALSH_SPI_WriteEnable();

    FLASH_SPI_CS_STATE(ON);

    FLASH_SPI_SendAReceiveByte(SECTOR_ERASE);

    FLASH_SPI_SendAReceiveByte((addr >> 16) & 0xFF);
    FLASH_SPI_SendAReceiveByte((addr >> 8) & 0xFF);
    FLASH_SPI_SendAReceiveByte(addr & 0xFF);

    FLASH_SPI_CS_STATE(OFF);

    FLASH_SPI_WaitInnerStead();
}

/**
  * @brief  FLASHдһҳ
  * @param  addr:д뵽ַ
  * @param  writeBuffer:дݵĻָ
  * @param  numBytetoWrite:дֽܳ FLASH_PAGESIZE
  * @retval 
  */
void FLASH_SPI_PageWrite(uint32_t addr, uint8_t* writeBuffer, uint16_t numBytetoWrite)
{
    FALSH_SPI_WriteEnable();

    FLASH_SPI_CS_STATE(ON);

    FLASH_SPI_SendAReceiveByte(WRITE_PAGE_PROGRAM);

    FLASH_SPI_SendAReceiveByte((addr >> 16) & 0xFF);
    FLASH_SPI_SendAReceiveByte((addr >> 8) & 0xFF);
    FLASH_SPI_SendAReceiveByte(addr & 0xFF);

    if(numBytetoWrite > FLASH_PAGESIZE)
    {
        numBytetoWrite = FLASH_PAGESIZE;
        FLASH_ERROR("\nдֽÿҳдֽ\n");
    }

    while(numBytetoWrite--)
    {
        FLASH_SPI_SendAReceiveByte(*writeBuffer);

        writeBuffer++;
    }

    FLASH_SPI_CS_STATE(OFF);

    FLASH_SPI_WaitInnerStead();
}

/**
  * @brief  FLASHе
  * @param  readAddr:Ҫĵַ
  * @param  readBuffer:ŶݵĻָ
  * @param  numBytetoWrite:Ҫֽ
  * @retval 
  */
void FLASH_SPI_BufferRead(uint32_t readAddr, uint8_t* readBuffer, uint16_t numBytetoRead)
{
    FLASH_SPI_CS_STATE(ON);

    FLASH_SPI_SendAReceiveByte(READ_DATA);

    FLASH_SPI_SendAReceiveByte((readAddr >> 16) & 0xFF);
    FLASH_SPI_SendAReceiveByte((readAddr >> 8) & 0xFF);
    FLASH_SPI_SendAReceiveByte(readAddr & 0xFF);

    while(numBytetoRead--)
    {
        *readBuffer = FLASH_SPI_SendAReceiveByte(Dummy_Byte);

        readBuffer++;
    }

    FLASH_SPI_CS_STATE(OFF);
}










