#pragma once

#include "ch32v30x.h"
#include "usart.h"

//SPI 
#define FLASH_SPIx                          SPI1
#define FLASH_SPI_PERIPH                    RCC_APB2Periph_SPI1
#define FLASH_SPI_CLOCKCMD                  RCC_APB2PeriphClockCmd

//SPI FLASH GPIO
//CS
#define FLASH_SPI_CS_GPIO_CLOCKCMD          RCC_APB2PeriphClockCmd
#define FLASH_SPI_CS_GPIO_PIN               GPIO_Pin_4
#define FLASH_SPI_CS_GPIO_PORT              GPIOA
#define FLASH_SPI_CS_GPIO_PERIPH            RCC_APB2Periph_GPIOA

//SCK
#define FLASH_SPI_SCK_GPIO_CLOCKCMD         RCC_APB2PeriphClockCmd
#define FLASH_SPI_SCK_GPIO_PIN              GPIO_Pin_5
#define FLASH_SPI_SCK_GPIO_PORT             GPIOA
#define FLASH_SPI_SCK_GPIO_PERIPH           RCC_APB2Periph_GPIOA

//MISO
#define FLASH_SPI_MISO_GPIO_CLOCKCMD        RCC_APB2PeriphClockCmd
#define FLASH_SPI_MISO_GPIO_PIN             GPIO_Pin_6
#define FLASH_SPI_MISO_GPIO_PORT            GPIOA
#define FLASH_SPI_MISO_GPIO_PERIPH          RCC_APB2Periph_GPIOA

//MOSI
#define FLASH_SPI_MOSI_GPIO_CLOCKCMD        RCC_APB2PeriphClockCmd
#define FLASH_SPI_MOSI_GPIO_PIN             GPIO_Pin_7
#define FLASH_SPI_MOSI_GPIO_PORT            GPIOA
#define FLASH_SPI_MOSI_GPIO_PERIPH          RCC_APB2Periph_GPIOA



//FLASHָ
#define WRITE_ENABLE                        0x06
#define READ_STATUS_REGISTER1               0x05
#define WRITE_PAGE_PROGRAM                  0x02
#define POWER_DOWN                          0xB9
#define RELEASE_POWER_DOWN                  0xAB
#define READ_DEVICE_ID                      0x90
#define READ_JEDEC_ID                       0x9F
#define READ_DATA                           0x03

//ָ
#define BLOCK_ERASE_64KB                    0xD8
#define BLOCK_ERASE_32KB                    0x52
#define SECTOR_ERASE                        0x20
#define CHIP_ERASE                          0x60




//W25Q64 FLASH 豸
#define JEDEC_ID                            0xEF4017
#define DEVICE_ID                           0xEF16

//W25Q64 FLASH ҳС
#define FLASH_PAGESIZE                      256

//ʱ͵
#define Dummy_Byte                          0xFF

//FLASH ڽڲʱ־
#define WIP_Flag                            0x01

//ȴʱʱ
#define SPI_FLAG_TIMEOUT                    200
#define SPI_LONG_TIMEOUT                    (10 * SPI_FLAG_TIMEOUT)


//Ϣ
#define FLASH_DEBUG_ON         0

#define FLASH_INFO(fmt,arg...)              printf("<<-FLASH-INFO->> "fmt"\n",##arg)
#define FLASH_ERROR(fmt,arg...)             printf("<<-FLASH-ERROR->> "fmt"\n",##arg)
#define FLASH_DEBUG(fmt,arg...)             do{\
                                              if(FLASH_DEBUG_ON)\
                                              printf("<<-FLASH-DEBUG->> [%d]"fmt"\n",__LINE__, ##arg);\
                                              }while(0)

#define ON      1
#define OFF     0

#define FLASH_SPI_CS_STATE(a)               if(a) GPIO_ResetBits(FLASH_SPI_CS_GPIO_PORT, FLASH_SPI_CS_GPIO_PIN);\
                                            else  GPIO_SetBits(FLASH_SPI_CS_GPIO_PORT, FLASH_SPI_CS_GPIO_PIN);

//#define FLASH_SPI_CS_LOW()                  GPIO_ResetBits(FLASH_SPI_CS_GPIO_PORT, FLASH_SPI_CS_GPIO_PIN)
//#define FLASH_SPI_CS_HIGH()                 GPIO_SetBits(FLASH_SPI_CS_GPIO_PORT, FLASH_SPI_CS_GPIO_PIN);


void FLASH_SPI_Init(void);
uint32_t FLASH_SPI_ReadID(void);
void FLASH_SPI_SectorErase(uint32_t addr);
void FLASH_SPI_PageWrite(uint32_t addr, uint8_t* writeBuffer, uint16_t numBytetoWrite);
void FLASH_SPI_BufferRead(uint32_t readAddr, uint8_t* readBuffer, uint16_t numBytetoRead);

