#include "usart.h"

//static void NVIC_USART_Config(void)
//{
//    NVIC_InitTypeDef NVIC_InitStruct;
//
//    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_1);
//
//    NVIC_InitStruct.NVIC_IRQChannel = USARTx_IRQN;
//    NVIC_InitStruct.NVIC_IRQChannelPreemptionPriority = 1;
//    NVIC_InitStruct.NVIC_IRQChannelSubPriority = 1;
//    NVIC_InitStruct.NVIC_IRQChannelCmd = ENABLE;
//    NVIC_Init(&NVIC_InitStruct);
//}

void USART_Config(void)
{
    GPIO_InitTypeDef  GPIO_InitStruct;
    USART_InitTypeDef USART_InitStruct;

    RCC_APB2PeriphClockCmd(USART_GPIO_CLK, ENABLE);

    RCC_APB2PeriphClockCmd(USART_PERIPH_CLK, ENABLE);

    GPIO_InitStruct.GPIO_Pin = USART_GPIO_TX_PIN;
    GPIO_InitStruct.GPIO_Mode = GPIO_Mode_AF_PP;
    GPIO_InitStruct.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(USART_GPIO_TX_PORT, &GPIO_InitStruct);

    GPIO_InitStruct.GPIO_Pin = USART_GPIO_RX_PIN;
    GPIO_InitStruct.GPIO_Mode = GPIO_Mode_IN_FLOATING;
    GPIO_Init(USART_GPIO_RX_PORT, &GPIO_InitStruct);

    USART_InitStruct.USART_BaudRate = USART_BAUDRATE;
    USART_InitStruct.USART_WordLength = USART_WordLength_8b;
    USART_InitStruct.USART_Parity = USART_Parity_No;
    USART_InitStruct.USART_StopBits = USART_StopBits_1;
    USART_InitStruct.USART_Mode = USART_Mode_Tx | USART_Mode_Rx;
    USART_InitStruct.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
    USART_Init(DEBUG_USARTx, &USART_InitStruct);

//    NVIC_USART_Config();
//
//    USART_ITConfig(DEBUG_USARTx, USART_IT_RXNE, ENABLE);

    USART_Cmd(DEBUG_USARTx, ENABLE);
}

//һֽ
void USART_SendByte(USART_TypeDef* USARTx, uint8_t data)
{
    USART_SendData(USARTx, data);
    while(USART_GetFlagStatus(USARTx, USART_FLAG_TXE) != SET) ;
}

//ֽ
void USART_SendHalfWord(USART_TypeDef* USARTx, uint16_t data)
{
    USART_SendData(USARTx, ((data & 0xff00) >> 8));
    while(USART_GetFlagStatus(USARTx, USART_FLAG_TXE) != SET) ;

    USART_SendData(USARTx, (data & 0xff));
    while(USART_GetFlagStatus(USARTx, USART_FLAG_TXE) != SET) ;
}

//
void USART_SendArray(USART_TypeDef* USARTx, uint8_t* array, uint8_t num)
{
    uint8_t i = 0;
    while(num--)
    {
        USART_SendByte(USARTx, array[i]);
        i++;
    }
    while(USART_GetFlagStatus(USARTx, USART_FLAG_TC) != SET) ;
}

//ַ
void USART_SendString(USART_TypeDef* USARTx, uint8_t* str)
{
    while(*str != '\0')
    {
        USART_SendByte(USARTx, *str);
        str++;
    }
    while(USART_GetFlagStatus(USARTx, USART_FLAG_TC) != SET) ;
}

//ضc⺯printfڣضʹprintf
int fputc(int ch, FILE* f)
{
    //һֽݵ
    USART_SendData(DEBUG_USARTx, (uint8_t)ch);

    //ȴ
    while(USART_GetFlagStatus(DEBUG_USARTx, USART_FLAG_TXE) != SET) ;

    return (ch);
}

//ضc⺯scanfڣضʹscanfgetcharȺ
int fgetc(FILE* f)
{
    //ȴ
    while(USART_GetFlagStatus(DEBUG_USARTx, USART_FLAG_RXNE) != SET) ;

    return (int)USART_ReceiveData(DEBUG_USARTx);
}
