/********************************** (C) COPYRIGHT *******************************
* File Name          : main.c
* Author             : WCH
* Version            : V1.0.0
* Date               : 2021/06/06
* Description        : Main program body.
*********************************************************************************
* Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
* Attention: This software (modified or not) and binary are used for 
* microcontroller manufactured by Nanjing Qinheng Microelectronics.
*******************************************************************************/

/*
 *@Note
 USART Print debugging routine:
 USART1_Tx(PA9).
 This example demonstrates using USART1(PA9) as a print debug port output.

*/

//#include "debug.h"
#include "flash_spi.h"
#include "ch32v30x.h"
#include "led.h"
#include "usart.h"

#include <string.h>

/* Global typedef */

/* Global define */
#define FLASH_WriteAddr         0x000000
#define FLASH_ReadAddr          FLASH_WriteAddr
#define FLASH_SectorErase       FLASH_WriteAddr

//#define BufferSize              sizeof(sendBuffer)
/* Global Variable */


uint8_t Test(void);

#define countof(a)      (sizeof(a) / sizeof(*(a)))
#define  BufferSize (countof(sendBuffer)-1)

uint8_t sendBuffer[] = "FLASHַ";

uint8_t readBuffer[BufferSize] = {0};


/*********************************************************************
 * @fn      main
 *
 * @brief   Main program.
 *
 * @return  none
 */
int main(void)
{
//	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
//	SystemCoreClockUpdate();
//	Delay_Init();
//	USART_Printf_Init(115200);
//	printf("SystemClk:%d\r\n",SystemCoreClock);
//	printf( "ChipID:%08x\r\n", DBGMCU_GetCHIPID() );
//	printf("This is printf example\r\n");

    Led_Init();
    USART_Config();
    FLASH_SPI_Init();


    if(Test())
    {
        LED1(ON);
        LED2(OFF);
    }
    else
    {
        LED1(OFF);
        LED2(ON);
    }


	while(1)
    {

	}
}

uint8_t Test(void)
{
    FLASH_INFO("\r\nһSPIȡFLASHĲʵ\r\n");

    uint32_t ID = FLASH_SPI_ReadID();

    FLASH_INFO("\r\nFLASH豸Ϊ: 0x%x\r\n", ID);

    if(ID == JEDEC_ID)
    {
        FLASH_INFO("\r\n豸ƥɹ\r\n");

        FLASH_SPI_SectorErase(FLASH_SectorErase);

        FLASH_SPI_PageWrite(FLASH_WriteAddr, sendBuffer, BufferSize);
        FLASH_INFO("\nдΪ: %s\n", sendBuffer);

        FLASH_SPI_BufferRead(FLASH_ReadAddr, readBuffer, BufferSize);
        FLASH_INFO("\nΪ: %s\r\n", readBuffer);

        if(strcmp(sendBuffer, readBuffer) == 0)
        {
            FLASH_INFO("\nдͬ\r\n");
        }
        else
        {
            FLASH_ERROR("\r\nдݲͬ\n");
        }

        return 1;
    }
    else
    {
        FLASH_ERROR("\r\n豸ƥʧܣ\r\n");

        return 0;
    }
}

